<?php
/**
 * Clase Base FN para BaseCrClienteTelefonoFN
 *
 * @package    
 * @subpackage BaseCrClienteTelefonoFN
 * @author     Willy
 * @version    SVN:: BaseCrClienteTelefonoFN.class.php,v 1.1 2014-10-30 10:17:45 william.taype Exp $
 */
class BaseCrClienteTelefonoFN extends CrClienteTelefonoBN
{
  private static $fieldNames = array (
    'IdTelefono'=>'IdTelefono', 'IdCliente'=>'IdCliente', 'IdTipoTelefono'=>'IdTipoTelefono', 'NombreTipoTelefono'=>'NombreTipoTelefono', 'Pertenece'=>'Pertenece', 'IdOperador'=>'IdOperador', 'NombreOperador'=>'NombreOperador', 'Numero'=>'Numero', 'FechaRegistro'=>'FechaCreacion', 'UsuarioRegistro'=>'UsuarioCreacion', 'FechaActualizacion'=>'FechaModificacion', 'UsuarioActualizacion'=>'UsuarioModificacion', 'Eliminado'=>'Eliminado', 'FechaEliminado'=>'FechaEliminado', 'UsuarioEliminado'=>'UsuarioEliminado', 'Estado'=>'Estado'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdTelefono, IdCliente, IdTipoTelefono, NombreTipoTelefono, Pertenece, IdOperador, NombreOperador, Numero, Comentario, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, FechaEliminado, UsuarioEliminado, Estado FROM cr_cliente_telefono WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdTelefono, IdCliente, IdTipoTelefono, NombreTipoTelefono, Pertenece, IdOperador, NombreOperador, Numero, Comentario, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, FechaEliminado, UsuarioEliminado, Estado FROM cr_cliente_telefono WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdTelefono()){ $where .= " AND idtelefono = '".$this->getIdTelefono()."'"; }
      if($this->getIdCliente()){ $where .= " AND idcliente = '".$this->getIdCliente()."'"; }
      if($this->getIdTipoTelefono()){ $where .= " AND idtipotelefono = '".$this->getIdTipoTelefono()."'"; }
      if($this->getNombreTipoTelefono()){ $where .= " AND nombretipotelefono = '".$this->getNombreTipoTelefono()."'"; }
      if($this->getPertenece()){ $where .= " AND pertenece = '".$this->getPertenece()."'"; }
      if($this->getIdOperador()){ $where .= " AND idoperador = '".$this->getIdOperador()."'"; }
      if($this->getNombreOperador()){ $where .= " AND nombreoperador = '".$this->getNombreOperador()."'"; }
      if($this->getNumero()){ $where .= " AND numero = '".$this->getNumero()."'"; }
      if($this->getComentario()){ $where .= " AND comentario = '".$this->getComentario()."'"; }
      if($this->getFechaRegistro()){ $where .= " AND fechacreacion = '".$this->getFechaRegistro()."'"; }
      if($this->getUsuarioRegistro()){ $where .= " AND usuariocreacion = '".$this->getUsuarioRegistro()."'"; }
      if($this->getFechaActualizacion()){ $where .= " AND fechamodificacion = '".$this->getFechaActualizacion()."'"; }
      if($this->getUsuarioActualizacion()){ $where .= " AND usuariomodificacion = '".$this->getUsuarioActualizacion()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getFechaEliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaEliminado()."'"; }
      if($this->getUsuarioEliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioEliminado()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdTelefono, IdCliente, IdTipoTelefono, NombreTipoTelefono, Pertenece, IdOperador, NombreOperador, Numero, Comentario, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, FechaEliminado, UsuarioEliminado, Estado FROM cr_cliente_telefono WHERE 1 AND IdTelefono='".$this->getIdTelefono()."'; ";
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrClienteTelefonoFN = new BaseCrClienteTelefonoFN();
    $o_BaseCrClienteTelefonoFN->setIdTelefono($o_propel->IdTelefono);
    $o_BaseCrClienteTelefonoFN->setIdCliente($o_propel->IdCliente);
    $o_BaseCrClienteTelefonoFN->setIdTipoTelefono($o_propel->IdTipoTelefono);
    $o_BaseCrClienteTelefonoFN->setNombreTipoTelefono($o_propel->NombreTipoTelefono);
    $o_BaseCrClienteTelefonoFN->setPertenece($o_propel->Pertenece);
    $o_BaseCrClienteTelefonoFN->setIdOperador($o_propel->IdOperador);
    $o_BaseCrClienteTelefonoFN->setNombreOperador($o_propel->NombreOperador);
    $o_BaseCrClienteTelefonoFN->setNumero($o_propel->Numero);
    $o_BaseCrClienteTelefonoFN->setComentario($o_propel->Comentario);
    $o_BaseCrClienteTelefonoFN->setFechaRegistro($o_propel->FechaCreacion);
    $o_BaseCrClienteTelefonoFN->setUsuarioRegistro($o_propel->UsuarioCreacion);
    $o_BaseCrClienteTelefonoFN->setFechaActualizacion($o_propel->FechaModificacion);
    $o_BaseCrClienteTelefonoFN->setUsuarioActualizacion($o_propel->UsuarioModificacion);
    $o_BaseCrClienteTelefonoFN->setEliminado($o_propel->Eliminado);
    $o_BaseCrClienteTelefonoFN->setFechaEliminado($o_propel->FechaEliminado);
    $o_BaseCrClienteTelefonoFN->setUsuarioEliminado($o_propel->UsuarioEliminado);
    $o_BaseCrClienteTelefonoFN->setEstado($o_propel->Estado);
    return $o_BaseCrClienteTelefonoFN;
  }
}